;FUNCTIONS;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GLOBAL error

;VARIABLES;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GLOBAL under_emu
GLOBAL vbl_cnt
GLOBAL emu_friendly_mode
GLOBAL temp_storage
GLOBAL done

;EQUATES;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LOOKUP_BANK		EQU	1
PADDLE_LOOKUP_HI	EQU	$3E	;high byte of adress


;palette usage EQU's
;a good number of these palettes are nearly indentical
;but I'm in no danger of running out of palettes, so need
;to optimize
			RSRESET
BALL_PAL		RB	2
RADAR_PAL		RB	1
SCORE_PAL		RB	1
PADDLE_PAL		RB	1
ENDGAME_PAL		RB	1

;sprite tile usage EQU's
			RSRESET
BALL_TILES		RW	4
RADAR_TILES		RW	2
SCORE_TILES		RW	10
PADDLE_TILES		RW	15

;sprite usage EQU's
			RSRESET
RADAR_SPRITES		RB	2
SCORE_SPRITES		RB	8
NEAR_PADDLE_SPRITES	RB	8*2
BALL_SPRITES		RB	4
FAR_PADDLE_SPRITES	RB	2
ENDGAME_TILES		RW	16

;title sprite positions
TITLE_SPR_STARTING_X	EQU	$80
TITLE_SPR_ENDING_X	EQU	$10
TITLE_SPR_Y		EQU	$20

;floater positions (takes sprite possition offset into account)
FLOATER_X	EQU	111+8
FLOATER_Y	EQU	135+16

DOT_X		EQU	120+8
DOT_Y		EQU	135+16

;score positions (takes sprite possition offset into account)
SCORE_X		EQU	63+8
SCORE_Y		EQU	102+16

SCORE_HEIGHT	EQU	15	;per letter
SCORE_WIDTH	EQU	7	;per letter

;endgame sign positions
ENDGAME_Y	EQU	$30
ENDGAME_START_X	EQU	-8*8
ENDGAME_END_X	EQU	$50

;paddle states
NO_WHACK		EQU	0
LEFT_WHACK		EQU	1
RIGHT_WHACK		EQU	2

WHACK_DELAY		EQU	15

;paddle y positions
FAR_PADDLE_Y_POS	EQU	$2A
NEAR_PADDLE_Y_POS	EQU	$26

;paddle width (in the game field)
PADDLE_WIDTH		EQU	25

;paddle velocity (pixels/frame)
PADDLE_VEL		EQU	2

AI_WHACK_THRESHOLD	EQU	8	;whack when the ball is closer than this

;argument for some functions
NEAR_PADDLE	EQU	0
FAR_PADDLE	EQU	1

;COMMAND QUEUE FORMAT: %01112222
;0 = paddle to affect (for communications)
;1 = command
;2 = argument
CMD_PADDLE_ID	EQU	%10000000
CMD_COMMAND	EQU	%01110000
CMD_ARG		EQU	%00001111

;
;commands:
;all directions are relative to the screen
;0 nop
CMD_NOP		EQU	%00000000

;1 move
;  }0 left
;  }1 right
CMD_MOVE	EQU	%00010000

;2 whack
;  }0 left
;  }1 right
CMD_WHACK	EQU	%00100000

;7 error
CMD_ERROR	EQU	%01110000

CMD_ARG_LEFT	EQU	%00000000
CMD_ARG_RIGHT	EQU	%00000001


;MACROS;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ldhlpp:	macro	;destroys BC
	ld HL,\1
	and A,A
	jp z,.skip\@
	ld BC,PADDLE_LEN
	add HL,BC
.skip\@	
	ENDM